<?php
/**
 * Copyright 2025 Flex Clam Server for Plesk
 *
 * Permission is hereby not granted to manipulate, modify or adapt the code;
 * as well as obtain a copy of this software or the associated documentation.
 * It is not allowed to publish, distribute, sublicense and/or sell copies of the Software,
 * without the consent of the author or creator of the software.
 *
 * The above copyright notice and this permission notice will be included
 * on all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT
 * AUTHORS OR COPYRIGHT HOLDERS WILL BE RESPONSIBLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION,
 * TORT OR OTHERWISE, ARISING OUT OF OR IN CONNECTION WITH THE SOFTWARE OR USE.
 *
 * @copyright 2025 Flex Clam Server for Plesk
 * @author Flex Antivirus <info@antivirus.flexservices.app>
 * @license Copyright
 */

pm_Loader::registerAutoload();

pm_Context::init('flex-clam-server');

try{

	$upgrade = false;

	$toVersion=pm_Settings::get('version','0.0.0');
	$fromVersion='0.0.0';
	if(count($argv)>1){
		$fromVersion = ($argv[1] === 'upgrade') ? $argv[2] : '0.0.0';
		if($argv[1] === 'upgrade'){$upgrade = true;}
	}

	if(!$upgrade){
		Modules_FlexClamServer_Settings::Save("Job", "Init");
		Modules_FlexClamServer_Settings::Save("PROMO", "Beta");
		Modules_FlexClamServer_Settings::Save("EnableAutoScan", "1");
		Modules_FlexClamServer_Settings::Save("EnableNotiEmail", "0");
		Modules_FlexClamServer_Settings::Save("AutoScanActionSYS", "nothing");
		Modules_FlexClamServer_Settings::Save("AutoScanActionDOM", "nothing");


		$InstallTask = pm_Settings::get('InstallTask',null);

		if ( $InstallTask == null ) {

			$task = new pm_Scheduler_Task();
			$task->setSchedule(array(
			'minute' => '*',
			'hour' => '*',
			'dom' => '*',
			'month' => '*',
			'dow' => '*'
			 ));
			$task->setCmd('install-task.php');
			pm_Scheduler::getInstance()->putTask($task);
			pm_Settings::set('InstallTask', $task->getId());
		}


		
	}else{
		if(Modules_FlexClamServer_Settings::Get("Job", "Init")!=="Init"){
			pm_ApiCli::callSbin("FlexClamServer.exe",array("/plesk","/install"));
		}
	}

	if ( pm_Settings::get('TaskId_AutoTypeScan') == null ) {
		pm_Settings::set("AutoTypeScan", "night");
		Modules_FlexClamServer_Settings::AutoTypeScan();
	}

	if ( pm_Settings::get('TaskId_AutoTypeRam') == null ) {
		pm_Settings::set("AutoTypeRam", "night");
		Modules_FlexClamServer_Settings::AutoTypeRam();
	}

	$AlertTask = pm_Settings::get('AlertTask',null);

	if ( $AlertTask == null ) {

			$task = new pm_Scheduler_Task();
			$task->setSchedule(array(
			'minute' => '*',
			'hour' => '7,15,23',
			'dom' => '*',
			'month' => '*',
			'dow' => '*'
			 ));
			$task->setCmd('alert-task.php');
			pm_Scheduler::getInstance()->putTask($task);
			pm_Settings::set('AlertTask', $task->getId());
	}else{
		$fileManager = new pm_ServerFileManager();
		$filePath = pm_Context::getVarDir() . "\\Alert.cfg";
		if ($fileManager->fileExists($filePath)) {$fileManager->removeFile($filePath);}
	}


	if(isset($_SESSION['flex-clam-server']['Activity'])){unset($_SESSION['flex-clam-server']['Activity']);}


	exit(0);

}catch(exception $e){

	pm_Log::err('Error Setup : ' . $e->getMessage());
	echo "\n";
	echo $e->getMessage();
	exit(1);
}



